#property copyright "Copyright  2011, Currency Messenger"
#property link      "http://currencymessenger.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 LightSkyBlue
#property indicator_color7 LightSkyBlue
#property indicator_color8 Yellow

extern int BandPeriod = 20;
extern int Fast = 12;
extern int Slow = 26;
extern int Smooth = 5;
extern double StdDevNumber = 1.0;
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];
double g_ibuf_124[];
double g_ibuf_128[];

int init() {
   IndicatorBuffers(8);
   SetIndexBuffer(0, g_ibuf_100);
   SetIndexBuffer(1, g_ibuf_104);
   SetIndexBuffer(2, g_ibuf_108);
   SetIndexBuffer(3, g_ibuf_112);
   SetIndexBuffer(4, g_ibuf_116);
   SetIndexBuffer(5, g_ibuf_120);
   SetIndexBuffer(6, g_ibuf_124);
   SetIndexBuffer(7, g_ibuf_128);
   SetIndexLabel(0, "BBMACD");
   SetIndexLabel(1, "UpBBMACD");
   SetIndexLabel(2, "DnBBMACD");
   SetIndexLabel(3, "UpAverage");
   SetIndexLabel(4, "DnAverage");
   SetIndexLabel(5, "Upper");
   SetIndexLabel(6, "Lower");
   SetIndexLabel(7, "MACDCross");
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_ARROW,EMPTY,1);
   SetIndexArrow(1, 108);
   SetIndexStyle(2, DRAW_ARROW,EMPTY,1);
   SetIndexArrow(2, 108);
   SetIndexStyle(3, DRAW_LINE, STYLE_DASH);
   SetIndexStyle(4, DRAW_LINE, STYLE_DASH);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexStyle(7, DRAW_ARROW,EMPTY,3);
   SetIndexArrow(7, 108);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double l_imacd_24;
   double ld_32;
   double ld_44;
   double ld_52;
   int l_ind_counted_0 = IndicatorCounted();
   int li_4 = Bars - l_ind_counted_0;
   
   for (int l_shift_20 = li_4; l_shift_20 >= 0; l_shift_20--) {
      l_imacd_24 = iMACD(Symbol(), 0, Fast, Slow, Smooth, PRICE_CLOSE, MODE_MAIN, l_shift_20);
      g_ibuf_100[l_shift_20] = l_imacd_24;
      if (g_ibuf_100[l_shift_20] > g_ibuf_100[l_shift_20 + 1]) {
         g_ibuf_104[l_shift_20] = g_ibuf_100[l_shift_20];
         g_ibuf_108[l_shift_20] = EMPTY_VALUE;
      } else {
         g_ibuf_108[l_shift_20] = g_ibuf_100[l_shift_20];
         g_ibuf_104[l_shift_20] = EMPTY_VALUE;
      }
      ld_32 = 0;
      for (int li_40 = l_shift_20 + BandPeriod - 1; li_40 >= l_shift_20; li_40--) ld_32 += g_ibuf_100[li_40];
      ld_44 = ld_32 / BandPeriod;
      ld_32 = 0;
      for (li_40 = l_shift_20 + BandPeriod - 1; li_40 >= l_shift_20; li_40--) ld_32 += (g_ibuf_100[li_40] - ld_44) * (g_ibuf_100[li_40] - ld_44);
      ld_52 = MathSqrt(ld_32 / BandPeriod);
      if (g_ibuf_100[l_shift_20] > ld_44) {
         g_ibuf_112[l_shift_20] = ld_44;
         g_ibuf_116[l_shift_20] = EMPTY_VALUE;
         if (g_ibuf_112[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_112[l_shift_20 + 1] = g_ibuf_116[l_shift_20 + 1];
      } else {
         if (g_ibuf_100[l_shift_20] < ld_44) {
            g_ibuf_116[l_shift_20] = ld_44;
            g_ibuf_112[l_shift_20] = EMPTY_VALUE;
            if (g_ibuf_116[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_116[l_shift_20 + 1] = g_ibuf_112[l_shift_20 + 1];
         } else {
            g_ibuf_112[l_shift_20] = g_ibuf_112[l_shift_20 + 1];
            g_ibuf_116[l_shift_20] = g_ibuf_116[l_shift_20];
         }
      }
      g_ibuf_120[l_shift_20] = ld_44 + StdDevNumber * ld_52;
      g_ibuf_124[l_shift_20] = ld_44 - StdDevNumber * ld_52;
      g_ibuf_128[l_shift_20] = EMPTY_VALUE;
      if (g_ibuf_100[l_shift_20] > 0.0) {
         if (g_ibuf_100[l_shift_20 + 1] <= 0.0) g_ibuf_128[l_shift_20] = 0;
      } else
         if (g_ibuf_100[l_shift_20 + 1] > 0.0) g_ibuf_128[l_shift_20] = 0;
   }
   return (0);
}